module grid {

    export class GridSprite extends egret.Sprite {

        public constructor() {
            super();

            // this.drawApex();

            // this.drawP();

            // this.checkIn();

            let detal = 10;
            let stage = egret.sys.$TempStage;
            let stageWidth = stage.stageWidth;
            let stagetHeight = stage.stageHeight;
            let mx = stageWidth >> 1;
            let my = stagetHeight >> 1;
            let left = mx - Math.floor((mx - 0) / detal)*detal;
            let right = mx + Math.floor((stageWidth - mx) / detal)*detal;
            let top = my - Math.floor((my - 0) / detal) * detal;
            let bottom = my + Math.floor((stagetHeight - my) / detal)*detal;

            let g = this.graphics;
            g.lineStyle(1, 0x000000);
            let pos = left;
            while (pos <= right) {
                g.moveTo(pos, top);
                g.lineTo(pos, bottom);
                pos += detal;
            }

            pos = top;
            while (pos <= bottom) {
                g.moveTo(left, pos);
                g.lineTo(right, pos);
                pos += detal;
            }

        }

        // private _oldP:Vertor2D;
        // private _firstP:Vertor2D;
        // private _Apexs:Vertor2D[] = [];
        // drawApex() {
        //     let g = this.graphics;
        //     g.lineStyle(1, 0x000000);
        //     for(let i = 0; i<3 ;i++){
        //         let p = new Vertor2D(Math.random()*200 +50 ,Math.random()*100+i*50);
        //         console.log("三角形的三个点坐标是：" ,Math.floor(p._x),Math.floor(p._y))
        //         if(this._oldP){
        //             g.moveTo(this._oldP._x, this._oldP._y);
        //             g.lineTo(p._x, p._y);
        //             if(i == 2){
        //                 let p = this._firstP;
        //                 g.lineTo(p._x, p._y);
        //             }
        //         }else{
        //             this._firstP = p;  
        //         }
        //         this._oldP = p;
        //         this._Apexs.push(p);
        //     }
        // }
        // private _P:Vertor2D;
        // drawP(){
        //     let g = this.graphics;
        //     g.lineStyle(3, 0x00CCFF);
        //     let p = this._P = new Vertor2D(Math.random()*100 + 50 ,Math.random()*100 + 50);
        //     g.drawCircle(p._x,p._y,3);
        //     console.log("顶点坐标是：" ,Math.floor(p._x),Math.floor(p._y))
        // }

        // checkIn(){
        //     let A = this._Apexs[0];
        //     let B = this._Apexs[1];
        //     let C = this._Apexs[2];
        //     let P = this._P;
        //     let AP = A.Minus(P);
        //     let BP = B.Minus(P);
        //     let CP = C.Minus(P);
        //     let T1 = AP.CrossProduct(BP);
        //     let T2 = BP.CrossProduct(CP);
        //     let T3 = CP.CrossProduct(AP);

        //     let result = T1*T2 >= 0 && T1*T3 >= 0;
        //     console.log(result);
            
        //     return result;
        // }
    }




}

class Vertor2D {
    constructor(_x: number, _y: number) {
        this._x = _x;
        this._y = _y;
    }

    public _x: number;

    public _y: number;

    /**差乘**/
    CrossProduct(_v: Vertor2D) {
        return this._x * _v._y - this._y * _v._x;
    }

    /**点积 */
    DotProduct(_v: Vertor2D) {
        return this._x * _v._x + this._y * _v._y;
    }

    /**减法 */
    Minus(_v: Vertor2D): Vertor2D {
        return new Vertor2D(this._x - _v._x, this._y - _v._y);
    }
}