module junyou.game {
    
    /**
     * 资源显示用位图
     */
    export class ResourceBitmap extends egret.Bitmap implements IRecyclable {
        public res: UnitResource;
  

        public draw(drawInfo: IDrawInfo,now: number) {
            this.res.draw(this,drawInfo,now);
        }
        
        public recycle(){
            ResourceBitmap._pool.recycle(this);
        }
        
        public onRecycle(){
            this.res = null;
        }
        public onSpawn(){}
        
        private static _pool:RecyclablePool<ResourceBitmap> = new RecyclablePool(ResourceBitmap);
        
        public static getInstance():ResourceBitmap{
            return this._pool.getInstance();
        }

    }
}
