module junyou.game {
	/**
	 * 平台数据
	 * @author 
	 *
	 */
	export class AuthData {
    	
    	/**
    	 * 平台标识
    	 */ 
        public pid: string;
        /**
         * 平台账号
         */ 
        public puid: string;
        /**
         * 平台服务器标识
         */ 
        public psid:string;
        /**
         * 服务器标识
         */ 
        public sid:number;
        /**
         * 会话标识
         */ 
        public sessionID: string;
        
        /**
         * 平台的验证数据
         */ 
        public token:string;
    	
		public constructor() {
		}
		
		public toURLString(){
		    return "pid="+encodeURIComponent(this.pid)+"&puid="+encodeURIComponent(this.puid)+
                "&psid=" + encodeURIComponent(this.psid) + "&token=" + encodeURIComponent(this.token);
		}
	}
}
