module junyou.game {
    import ByteArray = egret.ByteArray;
	/**
	 * 用于网络传输的消息类接口
	 * 单条消息，序列化后的长度，不可以超过65535
	 * @author 3tion
	 *
	 */
	export interface IMessage {
    	
        [index: string]: any;
        
        /**
         * 从字节流中读取
         */ 
        readFrom(bytes: ByteArray,len?:number):void;

        /**
         * 写入字节流
         */ 
        writeTo(bytes: ByteArray): ByteArray;
	}
}
