module junyou.game {
    
    
    export interface PBMessageConstructor{
        new ():PBMessage;
    }

    /**
	 * ProtoBuff的消息基类<br/>
	 * 指令由代码生成器自动生成
	 * @author 
	 *
	 */
    export class PBMessage implements IMessage{
        
    	/**
    	 * 消息配置
    	 */ 
        public mMessageEncode:Object;
        public messageHasFlag:boolean[];
    	
		public constructor() {

		}
		
        public has(idx: number): boolean
		{
            return this.messageHasFlag[idx];
        }

        public setHas(idx: number,value: boolean = true): void {
            this.messageHasFlag[idx] = value;
        }
        
        /**
         * 从字节流中读取
         */
        public readFrom(bytes: ByteArray,len?: number): void{
            PBMessageUtils.readFrom(this,bytes,len);
        }

        /**
         * 写入字节流
         */
        public writeTo(bytes: ByteArray): ByteArray{
            return PBMessageUtils.writeTo(this,bytes);
        }
	}
}
